#ifndef __ADC_STC8A8K64D4_H__
#define __ADC_STC8A8K64D4_H__



#define BIT0 0x01
#define BIT1 0x02
#define BIT2 0x04
#define BIT3 0x08
#define BIT4 0x10
#define BIT5 0x20
#define BIT6 0x40
#define BIT7 0x80

/*此处定义管脚配置*/
#define BIT10_0 0x7F	//1111 1110		0
#define BIT10_1 0x80	//0000 0001 	1
#define BIT12_0 0x7F	//1111 1101
#define BIT12_1 0x80	//0000 0010
#define BIT13_0 0x7F	//1111 1011
#define BIT13_1 0x80	//0000 0100
#define BIT14_0 0x7F	//1111 0111
#define BIT14_1 0x80	//0000 1000
#define BIT15_0 0x7F	//1110 1111
#define BIT15_1 0x80	//0001 0000
#define BIT16_0 0x7F	//1101 1111
#define BIT16_1 0x80	//0010 0000
#define BIT17_0 0x7F	//0111 1111		0
#define BIT17_1 0x80	//1000 0000		1
//					  	  7654 3210	
//					  	  |||| || |

/*------------------------------------------------------------------------*/
/*ADC_CONTR,ADCƼĴ,ַ0XBCH,λֵ000x0000B                        */
/*  bit7    |  bit6    |   bit5     | bit4       | bit3  bit2  bit1  bit0 */
/*ADC_POWER |ADC_START | ADC_FLAG   | ADC_EPWMT  |       ADC_CHS[3:0]     */
/*------------------------------------------------------------------------*/
//bit7,ADC_POWER:ADC power control bit
//bit6,ADC_START:ADC start control bit,1Ӳ0
//bit5,ADC_FLAG :ADC complete flagӲ10
//bit4,ADC_EPWMT:ʹPWMʵʱADC
//bit3-bit0,ADC_CHS[3:0]:ADCģͨѡ λ
//			ADC_CHS[3:0]:0-7,P1.0/ADC0-P1.7/ADC7 
//			ADC_CHS[3:0]:8-14,P0.0/ADC8-P0.6/ADC14
//			ADC_CHS[3:0]:15,ڲ1.19V׼ѹ
#define ADC_POWER 		0x80		
#define ADC_START 		0x40
#define ADC_FLAG  		0x20
#define ADC_EPWMT		0x10
#define ADC_channel0  	0x00		//P1.0/ADC0
#define ADC_channel1  	0x01		//P1.1/ADC1
#define ADC_channel2  	0x02		//P1.2/ADC2
#define ADC_channel3  	0x03		//P1.3/ADC3
#define ADC_channel4  	0x04		//P1.4/ADC4
#define ADC_channel5  	0x05		//P1.5/ADC5
#define ADC_channel6  	0x06		//P1.6/ADC6
#define ADC_channel7  	0x07		//P1.7/ADC7
#define ADC_channel8  	0x08		//P0.0/ADC8
#define ADC_channel9  	0x09		//P0.1/ADC9
#define ADC_channela  	0x0a		//P0.2/ADC10
#define ADC_channelb  	0x0b		//P0.3/ADC11
#define ADC_channelc  	0x0c		//P0.4/ADC12
#define ADC_channeld  	0x0d		//P0.5/ADC13
#define ADC_channele  	0x0e		//P0.6/ADC14
#define ADC_channelf   	0x0f		//ڲ1.19V׼/ADC15


/*-------------------------------------------------------------*/
/*ADC_CFG,ADCüĴ,ַ0XDEH,λֵxx0x0000B               */
/*  bit7   |  bit6  |  bit5   | bit4  | bit3  bit2  bit1  bit0 */
/*    x    |   x    | RESFMT  |   x   |       SPEED[3:0]       */
/*-------------------------------------------------------------*/
//bit7,Уδ
//bit6,Уδ
//bit5,RESFMT:ADC תʽλ,RESFMT = 0ת룻RESFMT = 1תҶ롣
//bit4,Уδ
//bit3-bit0,SPEED[3:0]:ADCʱӿλ,Fadc=SYSclk/2/16/(SPEED[3:0]+1) 
#define RESFMT  			0x20
#define ADCspeed32SYSclk 	0x00
#define ADCspeed64SYSclk 	0x01
#define ADCspeed96SYSclk 	0x02
#define ADCspeed128SYSclk 	0x03
#define ADCspeed160SYSclk 	0x04
#define ADCspeed192SYSclk 	0x05
#define ADCspeed224SYSclk 	0x06
#define ADCspeed256SYSclk 	0x07
#define ADCspeed288SYSclk 	0x08
#define ADCspeed320SYSclk 	0x09
#define ADCspeed352SYSclk 	0x0a
#define ADCspeed384SYSclk 	0x0b
#define ADCspeed416SYSclk 	0x0c
#define ADCspeed448SYSclk 	0x0d
#define ADCspeed480SYSclk 	0x0e
#define ADCspeed512SYSclk 	0x0f

/*--------------------------------------------------------------*/
/*ADCTIM,ADCʱƼĴ,ַ0xFEA8H,λֵ00101010B           */
/*  bit7    |  bit6    bit5  | bit4  bit3  bit2  bit1  bit0     */
/* CSSETUP  |   CSHOLD[1:0]  |         SMPDUTY[4:0]             */
/*--------------------------------------------------------------*/
//bit7,CSSETUP:ADCͨѡʱ λ	CSSETUP=0:ADCͨѡռ1ADCʱ(Ĭ)
//										CSSETUP=1:ADCͨѡռ2ADCʱӣ
//bit6-bit5,CSHOLD[1:0]:ADCͨѡ񱣳ʱλ
//				    =00:ռ1ADCʱ
//				    =01:ռ2ADCʱ(Ĭ)
//				    =10:ռ3ADCʱ
//				    =11:ռ4ADCʱ
//bit4-bit0,SMPDUTY[4:0]:ADCʱ λ
//			      =00000:ռ1ADCʱ 
//			      =00001:ռ2ADCʱ 
//			      =01001:ռ10ADCʱ 
//			      =01010:ռ11ADCʱ(Ĭ) SMPDUTY[4:0]òСڴֵ
//			      =01011:ռ12ADCʱ 
//			      =01100:ռ13ADCʱ 
//			      =11110:ռ31ADCʱ 
//			      =11111:ռ32ADCʱ 
#define CSSETUP  			0x80
#define CSHOLD1ADCclk  		0x00
#define CSHOLD2ADCclk  		0x20		//(Ĭ)
#define CSHOLD3ADCclk  		0x40
#define CSHOLD4ADCclk  		0x60
#define SMPDUTY11ADCclk  	0x0a		//(Ĭ)
#define SMPDUTY12ADCclk  	0x0b
#define SMPDUTY13ADCclk  	0x0c
#define SMPDUTY14ADCclk  	0x0d
#define SMPDUTY15ADCclk  	0x0e
#define SMPDUTY16ADCclk  	0x0f
#define SMPDUTY17ADCclk  	0x10
#define SMPDUTY18ADCclk  	0x11
#define SMPDUTY19ADCclk  	0x12
#define SMPDUTY20ADCclk  	0x13
#define SMPDUTY21ADCclk  	0x14
#define SMPDUTY22ADCclk  	0x15
#define SMPDUTY23ADCclk  	0x16
#define SMPDUTY24ADCclk  	0x17
#define SMPDUTY25ADCclk  	0x18
#define SMPDUTY26ADCclk  	0x19
#define SMPDUTY27ADCclk  	0x1a
#define SMPDUTY28ADCclk  	0x1b
#define SMPDUTY29ADCclk  	0x1c
#define SMPDUTY30ADCclk  	0x1d
#define SMPDUTY31ADCclk  	0x1e
#define SMPDUTY32ADCclk  	0x1f

//sfr DMA_ADC_CFG FA10H;
//sfr DMA_ADC_CR FA11H;
//sfr DMA_ADC_STA FA12H;
//sfr DMA_ADC_RXAH FA17H;
//sfr DMA_ADC_RXAL FA18H;
//sfr DMA_ADC_CFG2 FA19H;
//sfr DMA_ADC_CHSW0 FA1AH;
//sfr DMA_ADC_CHSW1 FA1BH;




extern unsigned char data AdcBufferH,AdcBufferL;
extern bit AdcFinished;
extern void initADC();



#endif