//       : oled.c
//     : о԰1.3SH1106OLED 4ӿڿ⺯(51ϵ)
//              GND  Դ
//              VCC  5V3.3vԴ
//              D0   SCL
//              D1   SDA
//******************************************************************************/
#include "stc8a8kxxd4.h"
#include "oled.h"
#include <intrins.h>

sbit OLED_SCL  = P5^5;//ʱ D0CLK
sbit OLED_SDIN = P5^4;// D1SDA

unsigned long code WeightOfDecimalDode[10] = {1,10,100,1000,10000,100000,1000000,10000000,100000000,1000000000};

void IIC_Start()
{
	OLED_SCLK_Set();OLED_SDIN_Set();OLED_SDIN_Clr();OLED_SCLK_Clr();
}

void IIC_Stop()
     {
     OLED_SCLK_Set();
//	OLED_SCLK_Clr();
     OLED_SDIN_Clr();OLED_SDIN_Set();
     }

void IIC_Wait_Ack()
{
	OLED_SCLK_Set();OLED_SCLK_Clr();
}

void Write_IIC_Byte(unsigned char IIC_Byte)	// IIC Write byte
{
	unsigned char i;
	unsigned char m,da;
	da=IIC_Byte;
	OLED_SCLK_Clr();
	for(i=0;i<8;i++)
	{
		m=da;
		//	OLED_SCLK_Clr();
		m=m&0x80;	//ȷλ
		if(m==0x80)
		{OLED_SDIN_Set();}
		else OLED_SDIN_Clr();
			da=da<<1;
		OLED_SCLK_Set();
		OLED_SCLK_Clr();
	}
}

void Write_IIC_Command(unsigned char IIC_Command)	// IIC Write Command
{
   IIC_Start();
   Write_IIC_Byte(0x78);            //Slave address,SA0=0
	IIC_Wait_Ack();
   Write_IIC_Byte(0x00);			//write command
	IIC_Wait_Ack();
   Write_IIC_Byte(IIC_Command);
	IIC_Wait_Ack();
   IIC_Stop();
}

void Write_IIC_Data(unsigned char IIC_Data)	// IIC Write Data
{
	IIC_Start();
	Write_IIC_Byte(0x78);			//R/W#=0
	IIC_Wait_Ack();
	Write_IIC_Byte(0x40);			//D/C#=1,write data
	IIC_Wait_Ack();
	Write_IIC_Byte(IIC_Data);
	IIC_Wait_Ack();
	IIC_Stop();
}
void OLED_WR_Byte(unsigned dat,unsigned cmd)
	{
	if(cmd)	{Write_IIC_Data(dat);}
	else 	{Write_IIC_Command(dat);}
	}

void OLED_Set_Pos(unsigned char x, unsigned char y)	//
{
	OLED_WR_Byte(0xb0+y,OLED_CMD);
	OLED_WR_Byte((((x+2)&0xf0)>>4)|0x10,OLED_CMD);
	OLED_WR_Byte(((x+2)&0x0f),OLED_CMD);
}


void OLED_Clear(void)	//,,ĻǺɫ!ûһ!!!
{
	u8 i,n;
	for(i=0;i<8;i++)
	{
		OLED_WR_Byte (0xb0+i,OLED_CMD);    //ҳַ0~7
		OLED_WR_Byte (0x02,OLED_CMD);      //ʾλáе͵ַ
		OLED_WR_Byte (0x10,OLED_CMD);      //ʾλáиߵַ
		for(n=0;n<128;n++)OLED_WR_Byte(0,OLED_DATA);
	} //ʾ
}

//ָλʾһַ,ַ
//x:0~127
//y:0~63
//mode:0,ʾ;1,ʾ
//size:ѡ 16/8
void OLED_ShowChar(u8 x,u8 y,u8 chr,u8 Char_Size)
{
	unsigned char c=0,i=0;
	c=chr-' ';//õƫƺֵ
	if(x>Max_Column-1){x=0;y=y+2;}
	if(Char_Size ==16)
		{
		OLED_Set_Pos(x,y);
		for(i=0;i<8;i++)
			OLED_WR_Byte(F8x16[c*16+i],OLED_DATA);
		OLED_Set_Pos(x,y+1);
		for(i=0;i<8;i++)
			OLED_WR_Byte(F8x16[c*16+i+8],OLED_DATA);
		}
	else    {
			OLED_Set_Pos(x,y);
			for(i=0;i<6;i++)
				OLED_WR_Byte(F6x8[c][i],OLED_DATA);
	        }
}


void OLED_ShowString(u8 x,u8 y,u8 *chr,u8 Char_Size)	//ʾһַ
	{
	unsigned char j=0;
	while (chr[j]!='\0')
		{
		OLED_ShowChar(x,y,chr[j],Char_Size);
		if(Char_Size== 8)	x+=6;
		else 				x+=8;
		if(x>120)
			{
			x=0;
			if(Char_Size==8)y+=1;
			else y+=2;
			}
		j++;
		}
	}
//void OledShowSignedCharacter(u8 x,u8 y,char chr,u8 Char_Size)
//	{
//	unsigned char idata i,j;
//	unsigned char idata BackOfChr;
//	unsigned int code WeightOfDecimalDode[3] = {1,10,100};
//		
//	if(chr < 0)	{chr *= -1;OLED_ShowChar(x,y,'-',Char_Size);}
//	else		{OLED_ShowChar(x,y,'-',Char_Size);}

//	BackOfChr = chr;      
//	j=0;
//	while(1)		//ݵĳ
//		{
//		if(chr == 0)
//			{
//			if(j==0)  { j++;}
//			break;
//			}
//		chr /= 10;
//		j++;
//		}
//	for(i=0;i<j;i++)	//λȡ
//		{
//		OLED_ShowChar(x + i*8 + 8,y,(BackOfChr / WeightOfDecimalDode[j-i-1]) + '0',Char_Size);
//		BackOfChr %= WeightOfDecimalDode[j-i-1];
//		}		      
//	}

void OledShowSignedInteger(u8 x,u8 y,int IntegerData,u8 Char_Size)
	{
	unsigned char idata i,j;
	unsigned int idata BackOfIntegerData;

	if(IntegerData < 0)	{OLED_ShowChar(x,y,'-',Char_Size);IntegerData *= -1;}
	else				{OLED_ShowChar(x,y,'+',Char_Size);}

	BackOfIntegerData = IntegerData;      
	j=0;
	while(1)		//ݵĳ
		{
		if(IntegerData == 0)
			{
			if(j==0)  { j++;}
			break;
			}
		IntegerData /= 10;
		j++;
		}
	for(i=0;i<j;i++)	//λȡ
		{
		OLED_ShowChar(x + i*8 + 8,y,(BackOfIntegerData / WeightOfDecimalDode[j-i-1]) + '0',Char_Size);
		BackOfIntegerData %= WeightOfDecimalDode[j-i-1];
		}	
	}	
	
void OledShowUnsignedInteger(u8 x,u8 y,unsigned int IntegerData,u8 Char_Size)
	{
	unsigned char idata i,j;
	unsigned int idata BackOfIntegerData;
	
	BackOfIntegerData = IntegerData;      
	j=0;
	while(1)		//ݵĳ
		{
		if(IntegerData == 0)
			{
			if(j==0)  { j++;}
			break;
			}
		IntegerData /= 10;
		j++;
		}
	for(i=0;i<j;i++)	//λȡ
		{
		OLED_ShowChar(x + i*8,y,(BackOfIntegerData / WeightOfDecimalDode[j-i-1]) + '0',Char_Size);
		BackOfIntegerData %= WeightOfDecimalDode[j-i-1];
		}	
	}
	
void OledShowUnsignedLong(u8 x,u8 y,unsigned long LongData,u8 Char_Size)
	{
	unsigned char idata i,j;
	unsigned long idata BackOfLongData;
	
	BackOfLongData = LongData;      
	j=0;
	while(1)		//ݵĳ
		{
		if(LongData == 0)
			{
			if(j==0)  { j++;}
			break;
			}
		LongData /= 10;
		j++;
		}
	for(i=0;i<j;i++)	//λȡ
		{
		OLED_ShowChar(x + i*8,y,(BackOfLongData / WeightOfDecimalDode[j-i-1]) + '0',Char_Size);
		BackOfLongData %= WeightOfDecimalDode[j-i-1];
		}	
	}

void OledClearUnsignedLong(u8 x,u8 y,unsigned long LongData,u8 Char_Size)
	{
	unsigned char idata i,j;
	j=0;
	while(1)		//ݵĳ
		{
		if(LongData == 0)
			{
			if(j==0)  { j++;}
			break;
			}
		LongData /= 10;
		j++;
		}
	for(i=0;i<j;i++)	//λ
		{
		OLED_ShowChar(x + i*8,y,' ',Char_Size);
		}
	}	
	
void OledClearUnsignedInteger(u8 x,u8 y,unsigned int IntegerData,u8 Char_Size)
	{
	unsigned char idata i,j;
	j=0;
	while(1)		//ݵĳ
		{
		if(IntegerData == 0)
			{
			if(j==0)  { j++;}
			break;
			}
		IntegerData /= 10;
		j++;
		}
	for(i=0;i<j;i++)	//λ
		{
		OLED_ShowChar(x + i*8,y,' ',Char_Size);
		}
	}	

void OledClearSignedInteger(u8 x,u8 y,int IntegerData,u8 Char_Size)
	{
	unsigned char idata i,j;
	if(IntegerData < 0)	{IntegerData *= -1;}
	
	j=0;
	while(1)		//ݵĳ
		{
		if(IntegerData == 0)
			{
			if(j==0)  { j++;}
			break;
			}
		IntegerData /= 10;
		j++;
		}
//	j++;	//У λ ռõ1ַ
	for(i=0;i<j;i++)	//λ
		{
		OLED_ShowChar(x + i*8 + 8,y,' ',Char_Size);
		}
	}	
	
void OledShowFloatWithoutPole(uchar xx,uchar yy,float x,uchar lenth)
	{
	unsigned char idata i,j;
	unsigned char idata userReg;
	unsigned long idata long_register;

	long_register = x;
	
    j=0;
	while(1)		//ݵĳ
		{
		if(long_register == 0)
			{
			if(j==0)  { j++;}
			break;
			}
		long_register /= 10;
		j++;
		}    
	long_register = x;
		
	for(i=0;i<j;i++)	//λȡ
		{
		OLED_ShowChar(xx + i*8,yy,(long_register / WeightOfDecimalDode[j-i-1]) + '0',16);
		long_register %= WeightOfDecimalDode[j-i-1];
		}	
	
	if( j >= lenth)		{return;}
	
	long_register = x;	
	x = x - long_register;		//С	
	OLED_ShowChar(xx + j*8,yy,'.',16);	
	
	for(i = 0;i < lenth - j - 1;i++)
		{
		userReg = x * 10;
		OLED_ShowChar(xx + j*8 + i*8 + 8,yy,userReg + '0',16);
		x *= 10;
		x -= userReg;
		}
	}	

void OledShowFloatWithPole(uchar xx,uchar yy,float x,uchar lenth)
	{
	unsigned char idata i,j;
	unsigned char idata userReg;
	unsigned long idata long_register;
	
    if(x < 0.0)	{OLED_ShowChar(xx,yy,'-',16);x *= -1;}
	else		{OLED_ShowChar(xx,yy,'+',16);}
	
	long_register = x;
	
    j=0;
	while(1)		//ݵĳ
		{
		if(long_register == 0)
			{
			if(j==0)  { j++;}
			break;
			}
		long_register /= 10;
		j++;
		}    
	long_register = x;
		
	for(i=0;i<j;i++)	//λȡ
		{
		OLED_ShowChar(xx + i*8 + 8,yy,(long_register / WeightOfDecimalDode[j-i-1]) + '0',16);
		long_register %= WeightOfDecimalDode[j-i-1];
		}	
	j++;	//У λ ռõ1ַ
		
	if( j >= lenth)		{return;}	//ִʾĳȣʾС
	
	long_register = x;	
	x = x - long_register;		//С	
	OLED_ShowChar(xx + j*8,yy,'.',16);	
	
	for(i = 0;i < lenth - j - 1;i++)
		{
		userReg = x * 10;
		OLED_ShowChar(xx + j*8 + i*8 + 8,yy,userReg + '0',16);
		x *= 10;
		x -= userReg;
		}
	}	
	
//ʼSSD1306
void OLED_Init(void)
{

	OLED_WR_Byte(0xAE,OLED_CMD);//--display off
	OLED_WR_Byte(0x02,OLED_CMD);//---set low column address
	OLED_WR_Byte(0x10,OLED_CMD);//---set high column address
	OLED_WR_Byte(0x40,OLED_CMD);//--set start line address
	OLED_WR_Byte(0xB0,OLED_CMD);//--set page address
	OLED_WR_Byte(0x81,OLED_CMD);// contract control
	OLED_WR_Byte(0x80,OLED_CMD);//--128
	OLED_WR_Byte(0xA1,OLED_CMD);//set segment remap
	OLED_WR_Byte(0xA6,OLED_CMD);//--normal / reverse
	OLED_WR_Byte(0xA8,OLED_CMD);//--set multiplex ratio(1 to 64)
	OLED_WR_Byte(0x3F,OLED_CMD);//--1/64 duty
	OLED_WR_Byte(0xC8,OLED_CMD);//Com scan direction
	OLED_WR_Byte(0xD3,OLED_CMD);//-set display offset
	OLED_WR_Byte(0x00,OLED_CMD);//

	OLED_WR_Byte(0xD5,OLED_CMD);//set osc division
	OLED_WR_Byte(0x80,OLED_CMD);//

//	OLED_WR_Byte(0xD8,OLED_CMD);//set area color mode off
//	OLED_WR_Byte(0x05,OLED_CMD);//

	OLED_WR_Byte(0xD9,OLED_CMD);//Set Pre-Charge Period
	OLED_WR_Byte(0xF1,OLED_CMD);//Pre-Charge 15 Clocks & Discharge 1 Clock

	OLED_WR_Byte(0xDA,OLED_CMD);//set com pin configuartion
	OLED_WR_Byte(0x12,OLED_CMD);//

	OLED_WR_Byte(0xDB,OLED_CMD);//set Vcomh
	OLED_WR_Byte(0x30,OLED_CMD);//0.77*Vcc(20HSSD1306ͬΪ0.77Vcc)

	OLED_WR_Byte(0x8D,OLED_CMD);//set charge pump enable
	OLED_WR_Byte(0x14,OLED_CMD);//

	OLED_WR_Byte(0xAF,OLED_CMD);//--turn on oled panel


	OLED_Clear();
}

//OLEDԴŸʽ
//[0]0 1 2 3 ... 127
//[1]0 1 2 3 ... 127
//[2]0 1 2 3 ... 127
//[3]0 1 2 3 ... 127
//[4]0 1 2 3 ... 127
//[5]0 1 2 3 ... 127
//[6]0 1 2 3 ... 127
//[7]0 1 2 3 ... 127
//ASCII
//ƫ32
//ASCIIַ
//ƫ32
//С:12*6
/************************************6*8ĵ************************************/
const unsigned char code F6x8[][6] =
{
0x00, 0x00, 0x00, 0x00, 0x00, 0x00,// sp
0x00, 0x00, 0x00, 0x2f, 0x00, 0x00,// !
0x00, 0x00, 0x07, 0x00, 0x07, 0x00,// "
0x00, 0x14, 0x7f, 0x14, 0x7f, 0x14,// #
0x00, 0x24, 0x2a, 0x7f, 0x2a, 0x12,// $
0x00, 0x62, 0x64, 0x08, 0x13, 0x23,// %
0x00, 0x36, 0x49, 0x55, 0x22, 0x50,// &
0x00, 0x00, 0x05, 0x03, 0x00, 0x00,// '
0x00, 0x00, 0x1c, 0x22, 0x41, 0x00,// (
0x00, 0x00, 0x41, 0x22, 0x1c, 0x00,// )
0x00, 0x14, 0x08, 0x3E, 0x08, 0x14,// *
0x00, 0x08, 0x08, 0x3E, 0x08, 0x08,// +
0x00, 0x00, 0x00, 0xA0, 0x60, 0x00,// ,
0x00, 0x08, 0x08, 0x08, 0x08, 0x08,// -
0x00, 0x00, 0x60, 0x60, 0x00, 0x00,// .
0x00, 0x20, 0x10, 0x08, 0x04, 0x02,// /
0x00, 0x3E, 0x51, 0x49, 0x45, 0x3E,// 0
0x00, 0x00, 0x42, 0x7F, 0x40, 0x00,// 1
0x00, 0x42, 0x61, 0x51, 0x49, 0x46,// 2
0x00, 0x21, 0x41, 0x45, 0x4B, 0x31,// 3
0x00, 0x18, 0x14, 0x12, 0x7F, 0x10,// 4
0x00, 0x27, 0x45, 0x45, 0x45, 0x39,// 5
0x00, 0x3C, 0x4A, 0x49, 0x49, 0x30,// 6
0x00, 0x01, 0x71, 0x09, 0x05, 0x03,// 7
0x00, 0x36, 0x49, 0x49, 0x49, 0x36,// 8
0x00, 0x06, 0x49, 0x49, 0x29, 0x1E,// 9
0x00, 0x00, 0x36, 0x36, 0x00, 0x00,// :
0x00, 0x00, 0x56, 0x36, 0x00, 0x00,// ;
0x00, 0x08, 0x14, 0x22, 0x41, 0x00,// <
0x00, 0x14, 0x14, 0x14, 0x14, 0x14,// =
0x00, 0x00, 0x41, 0x22, 0x14, 0x08,// >
0x00, 0x02, 0x01, 0x51, 0x09, 0x06,// ?
0x00, 0x32, 0x49, 0x59, 0x51, 0x3E,// @
0x00, 0x7C, 0x12, 0x11, 0x12, 0x7C,// A
0x00, 0x7F, 0x49, 0x49, 0x49, 0x36,// B
0x00, 0x3E, 0x41, 0x41, 0x41, 0x22,// C
0x00, 0x7F, 0x41, 0x41, 0x22, 0x1C,// D
0x00, 0x7F, 0x49, 0x49, 0x49, 0x41,// E
0x00, 0x7F, 0x09, 0x09, 0x09, 0x01,// F
0x00, 0x3E, 0x41, 0x49, 0x49, 0x7A,// G
0x00, 0x7F, 0x08, 0x08, 0x08, 0x7F,// H
0x00, 0x00, 0x41, 0x7F, 0x41, 0x00,// I
0x00, 0x20, 0x40, 0x41, 0x3F, 0x01,// J
0x00, 0x7F, 0x08, 0x14, 0x22, 0x41,// K
0x00, 0x7F, 0x40, 0x40, 0x40, 0x40,// L
0x00, 0x7F, 0x02, 0x0C, 0x02, 0x7F,// M
0x00, 0x7F, 0x04, 0x08, 0x10, 0x7F,// N
0x00, 0x3E, 0x41, 0x41, 0x41, 0x3E,// O
0x00, 0x7F, 0x09, 0x09, 0x09, 0x06,// P
0x00, 0x3E, 0x41, 0x51, 0x21, 0x5E,// Q
0x00, 0x7F, 0x09, 0x19, 0x29, 0x46,// R
0x00, 0x46, 0x49, 0x49, 0x49, 0x31,// S
0x00, 0x01, 0x01, 0x7F, 0x01, 0x01,// T
0x00, 0x3F, 0x40, 0x40, 0x40, 0x3F,// U
0x00, 0x1F, 0x20, 0x40, 0x20, 0x1F,// V
0x00, 0x3F, 0x40, 0x38, 0x40, 0x3F,// W
0x00, 0x63, 0x14, 0x08, 0x14, 0x63,// X
0x00, 0x07, 0x08, 0x70, 0x08, 0x07,// Y
0x00, 0x61, 0x51, 0x49, 0x45, 0x43,// Z
0x00, 0x00, 0x7F, 0x41, 0x41, 0x00,// [
0x00, 0x55, 0x2A, 0x55, 0x2A, 0x55,// 55
0x00, 0x00, 0x41, 0x41, 0x7F, 0x00,// ]
0x00, 0x04, 0x02, 0x01, 0x02, 0x04,// ^
0x00, 0x40, 0x40, 0x40, 0x40, 0x40,// _
0x00, 0x00, 0x01, 0x02, 0x04, 0x00,// '
0x00, 0x20, 0x54, 0x54, 0x54, 0x78,// a
0x00, 0x7F, 0x48, 0x44, 0x44, 0x38,// b
0x00, 0x38, 0x44, 0x44, 0x44, 0x20,// c
0x00, 0x38, 0x44, 0x44, 0x48, 0x7F,// d
0x00, 0x38, 0x54, 0x54, 0x54, 0x18,// e
0x00, 0x08, 0x7E, 0x09, 0x01, 0x02,// f
0x00, 0x18, 0xA4, 0xA4, 0xA4, 0x7C,// g
0x00, 0x7F, 0x08, 0x04, 0x04, 0x78,// h
0x00, 0x00, 0x44, 0x7D, 0x40, 0x00,// i
0x00, 0x40, 0x80, 0x84, 0x7D, 0x00,// j
0x00, 0x7F, 0x10, 0x28, 0x44, 0x00,// k
0x00, 0x00, 0x41, 0x7F, 0x40, 0x00,// l
0x00, 0x7C, 0x04, 0x18, 0x04, 0x78,// m
0x00, 0x7C, 0x08, 0x04, 0x04, 0x78,// n
0x00, 0x38, 0x44, 0x44, 0x44, 0x38,// o
0x00, 0xFC, 0x24, 0x24, 0x24, 0x18,// p
0x00, 0x18, 0x24, 0x24, 0x18, 0xFC,// q
0x00, 0x7C, 0x08, 0x04, 0x04, 0x08,// r
0x00, 0x48, 0x54, 0x54, 0x54, 0x20,// s
0x00, 0x04, 0x3F, 0x44, 0x40, 0x20,// t
0x00, 0x3C, 0x40, 0x40, 0x20, 0x7C,// u
0x00, 0x1C, 0x20, 0x40, 0x20, 0x1C,// v
0x00, 0x3C, 0x40, 0x30, 0x40, 0x3C,// w
0x00, 0x44, 0x28, 0x10, 0x28, 0x44,// x
0x00, 0x1C, 0xA0, 0xA0, 0xA0, 0x7C,// y
0x00, 0x44, 0x64, 0x54, 0x4C, 0x44,// z
0x14, 0x14, 0x14, 0x14, 0x14, 0x14,// horiz lines
};
/****************************************8*16ĵ************************************/
//  D0| D1 D2 D3 D4 D5 D6 D7
//----------------------------------
//  0 | 0  0  0  0  0  0  0
//	1 | 1  1  1  1  1  1  1
//	2 | 2  2  2  2  2  2  2
//	3 | 3  3  3  3  3  3  3
//	4 | 4  4  4  4  4  4  4
//	5 | 5  5  5  5  5  5  5
//	6 | 6  6  6  6  6  6  6
//	7 | 7  7  7  7  7  7  7
//  0 | 0  0  0  0  0  0  0
//	1 | 1  1  1  1  1  1  1
//	2 | 2  2  2  2  2  2  2
//	3 | 3  3  3  3  3  3  3
//	4 | 4  4  4  4  4  4  4
//	5 | 5  5  5  5  5  5  5
//	6 | 6  6  6  6  6  6  6
//	7 | 7  7  7  7  7  7  7
//----------------------------------
//  D8 D9 D10D11D12D13D14D15

const unsigned char code F8x16[]=
{
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//  0
  0x00,0x00,0x00,0xF8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x33,0x30,0x00,0x00,0x00,//! 1
  0x00,0x10,0x0C,0x06,0x10,0x0C,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//" 2
  0x40,0xC0,0x78,0x40,0xC0,0x78,0x40,0x00,0x04,0x3F,0x04,0x04,0x3F,0x04,0x04,0x00,//# 3
  0x00,0x70,0x88,0xFC,0x08,0x30,0x00,0x00,0x00,0x18,0x20,0xFF,0x21,0x1E,0x00,0x00,//$ 4
  0xF0,0x08,0xF0,0x00,0xE0,0x18,0x00,0x00,0x00,0x21,0x1C,0x03,0x1E,0x21,0x1E,0x00,//% 5
  0x00,0xF0,0x08,0x88,0x70,0x00,0x00,0x00,0x1E,0x21,0x23,0x24,0x19,0x27,0x21,0x10,//& 6
  0x10,0x16,0x0E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//' 7
  0x00,0x00,0x00,0xE0,0x18,0x04,0x02,0x00,0x00,0x00,0x00,0x07,0x18,0x20,0x40,0x00,//( 8 
  0x00,0x02,0x04,0x18,0xE0,0x00,0x00,0x00,0x00,0x40,0x20,0x18,0x07,0x00,0x00,0x00,//) 9
  0x40,0x40,0x80,0xF0,0x80,0x40,0x40,0x00,0x02,0x02,0x01,0x0F,0x01,0x02,0x02,0x00,//* 10
  0x00,0x00,0x00,0xF0,0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x1F,0x01,0x01,0x01,0x00,//+ 11
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0xB0,0x70,0x00,0x00,0x00,0x00,0x00,//, 12
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x01,0x01,0x01,0x01,//- 13
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,0x00,0x00,//. 14
  0x00,0x00,0x00,0x00,0x80,0x60,0x18,0x04,0x00,0x60,0x18,0x06,0x01,0x00,0x00,0x00,/// 15
  0x00,0xE0,0x10,0x08,0x08,0x10,0xE0,0x00,0x00,0x0F,0x10,0x20,0x20,0x10,0x0F,0x00,//0 16
  0x00,0x10,0x10,0xF8,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x00,//1 17
  0x00,0x70,0x08,0x08,0x08,0x88,0x70,0x00,0x00,0x30,0x28,0x24,0x22,0x21,0x30,0x00,//2 18
  0x00,0x30,0x08,0x88,0x88,0x48,0x30,0x00,0x00,0x18,0x20,0x20,0x20,0x11,0x0E,0x00,//3 19
  0x00,0x00,0xC0,0x20,0x10,0xF8,0x00,0x00,0x00,0x07,0x04,0x24,0x24,0x3F,0x24,0x00,//4 20
  0x00,0xF8,0x08,0x88,0x88,0x08,0x08,0x00,0x00,0x19,0x21,0x20,0x20,0x11,0x0E,0x00,//5 21
  0x00,0xE0,0x10,0x88,0x88,0x18,0x00,0x00,0x00,0x0F,0x11,0x20,0x20,0x11,0x0E,0x00,//6 22
  0x00,0x38,0x08,0x08,0xC8,0x38,0x08,0x00,0x00,0x00,0x00,0x3F,0x00,0x00,0x00,0x00,//7 23
  0x00,0x70,0x88,0x08,0x08,0x88,0x70,0x00,0x00,0x1C,0x22,0x21,0x21,0x22,0x1C,0x00,//8 24
  0x00,0xE0,0x10,0x08,0x08,0x10,0xE0,0x00,0x00,0x00,0x31,0x22,0x22,0x11,0x0F,0x00,//9 25
  0x00,0x00,0x00,0xC0,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00,0x00,0x00,//: 26
  0x00,0x00,0x00,0x80,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x60,0x00,0x00,0x00,0x00,//; 27
  0x00,0x00,0x80,0x40,0x20,0x10,0x08,0x00,0x00,0x01,0x02,0x04,0x08,0x10,0x20,0x00,//< 28
  0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x00,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x00,//= 29
  0xc0,0xc0,0x78,0x70,0x60,0xc0,0x80,0x00,0x0f,0x0f,0x3c,0x1c,0x0c,0x06,0x03,0x01,//> 30  0x00,0x08,0x10,0x20,0x40,0x80,0x00,0x00,0x00,0x20,0x10,0x08,0x04,0x02,0x01,0x00,
  0x00,0x70,0x48,0x08,0x08,0x08,0xF0,0x00,0x00,0x00,0x00,0x30,0x36,0x01,0x00,0x00,//? 31
  0xC0,0x30,0xC8,0x28,0xE8,0x10,0xE0,0x00,0x07,0x18,0x27,0x24,0x23,0x14,0x0B,0x00,//@ 32
  0x00,0x00,0xC0,0x38,0xE0,0x00,0x00,0x00,0x20,0x3C,0x23,0x02,0x02,0x27,0x38,0x20,//A 33
  0x08,0xF8,0x88,0x88,0x88,0x70,0x00,0x00,0x20,0x3F,0x20,0x20,0x20,0x11,0x0E,0x00,//B 34
  0xC0,0x30,0x08,0x08,0x08,0x08,0x38,0x00,0x07,0x18,0x20,0x20,0x20,0x10,0x08,0x00,//C 35
  0x08,0xF8,0x08,0x08,0x08,0x10,0xE0,0x00,0x20,0x3F,0x20,0x20,0x20,0x10,0x0F,0x00,//D 36
  0x08,0xF8,0x88,0x88,0xE8,0x08,0x10,0x00,0x20,0x3F,0x20,0x20,0x23,0x20,0x18,0x00,//E 37
  0x08,0xF8,0x88,0x88,0xE8,0x08,0x10,0x00,0x20,0x3F,0x20,0x00,0x03,0x00,0x00,0x00,//F 38
  0xC0,0x30,0x08,0x08,0x08,0x38,0x00,0x00,0x07,0x18,0x20,0x20,0x22,0x1E,0x02,0x00,//G 39
  0x08,0xF8,0x08,0x00,0x00,0x08,0xF8,0x08,0x20,0x3F,0x21,0x01,0x01,0x21,0x3F,0x20,//H 40
  0x00,0x08,0x08,0xF8,0x08,0x08,0x00,0x00,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x00,//I 41
  0x00,0x00,0x08,0x08,0xF8,0x08,0x08,0x00,0xC0,0x80,0x80,0x80,0x7F,0x00,0x00,0x00,//J 42
  0x08,0xF8,0x88,0xC0,0x28,0x18,0x08,0x00,0x20,0x3F,0x20,0x01,0x26,0x38,0x20,0x00,//K 43
  0x08,0xF8,0x08,0x00,0x00,0x00,0x00,0x00,0x20,0x3F,0x20,0x20,0x20,0x20,0x30,0x00,//L 44
  0x08,0xF8,0xF8,0x00,0xF8,0xF8,0x08,0x00,0x20,0x3F,0x00,0x3F,0x00,0x3F,0x20,0x00,//M 45
  0x08,0xF8,0x30,0xC0,0x00,0x08,0xF8,0x08,0x20,0x3F,0x20,0x00,0x07,0x18,0x3F,0x00,//N 46
  0xE0,0x10,0x08,0x08,0x08,0x10,0xE0,0x00,0x0F,0x10,0x20,0x20,0x20,0x10,0x0F,0x00,//O 47
  0x08,0xF8,0x08,0x08,0x08,0x08,0xF0,0x00,0x20,0x3F,0x21,0x01,0x01,0x01,0x00,0x00,//P 48
  0xE0,0x10,0x08,0x08,0x08,0x10,0xE0,0x00,0x0F,0x18,0x24,0x24,0x38,0x50,0x4F,0x00,//Q 49
  0x08,0xF8,0x88,0x88,0x88,0x88,0x70,0x00,0x20,0x3F,0x20,0x00,0x03,0x0C,0x30,0x20,//R 50
  0x00,0x70,0x88,0x08,0x08,0x08,0x38,0x00,0x00,0x38,0x20,0x21,0x21,0x22,0x1C,0x00,//S 51
  0x18,0x08,0x08,0xF8,0x08,0x08,0x18,0x00,0x00,0x00,0x20,0x3F,0x20,0x00,0x00,0x00,//T 52
  0x08,0xF8,0x08,0x00,0x00,0x08,0xF8,0x08,0x00,0x1F,0x20,0x20,0x20,0x20,0x1F,0x00,//U 53
  0x08,0x78,0x88,0x00,0x00,0xC8,0x38,0x08,0x00,0x00,0x07,0x38,0x0E,0x01,0x00,0x00,//V 54
  0xF8,0x08,0x00,0xF8,0x00,0x08,0xF8,0x00,0x03,0x3C,0x07,0x00,0x07,0x3C,0x03,0x00,//W 55
  0x08,0x18,0x68,0x80,0x80,0x68,0x18,0x08,0x20,0x30,0x2C,0x03,0x03,0x2C,0x30,0x20,//X 56
  0x08,0x38,0xC8,0x00,0xC8,0x38,0x08,0x00,0x00,0x00,0x20,0x3F,0x20,0x00,0x00,0x00,//Y 57
  0x10,0x08,0x08,0x08,0xC8,0x38,0x08,0x00,0x20,0x38,0x26,0x21,0x20,0x20,0x18,0x00,//Z 58
  0x00,0x00,0x00,0xFE,0x02,0x02,0x02,0x00,0x00,0x00,0x00,0x7F,0x40,0x40,0x40,0x00,//[ 59
  0x00,0x0C,0x30,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x06,0x38,0xC0,0x00,//\ 60
  0x00,0x02,0x02,0x02,0xFE,0x00,0x00,0x00,0x00,0x40,0x40,0x40,0x7F,0x00,0x00,0x00,//] 61
  0x00,0x00,0x04,0x02,0x02,0x02,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//^ 62
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x80,//_ 63
  0x00,0x02,0x02,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//` 64
  0x00,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x19,0x24,0x22,0x22,0x22,0x3F,0x20,//a 65
  0x08,0xF8,0x00,0x80,0x80,0x00,0x00,0x00,0x00,0x3F,0x11,0x20,0x20,0x11,0x0E,0x00,//b 66
  0x00,0x00,0x00,0x80,0x80,0x80,0x00,0x00,0x00,0x0E,0x11,0x20,0x20,0x20,0x11,0x00,//c 67
  0x00,0x00,0x00,0x80,0x80,0x88,0xF8,0x00,0x00,0x0E,0x11,0x20,0x20,0x10,0x3F,0x20,//d 68
  0x00,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x1F,0x22,0x22,0x22,0x22,0x13,0x00,//e 69
  0x00,0x80,0x80,0xF0,0x88,0x88,0x88,0x18,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x00,//f 70
  0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x6B,0x94,0x94,0x94,0x93,0x60,0x00,//g 71
  0x08,0xF8,0x00,0x80,0x80,0x80,0x00,0x00,0x20,0x3F,0x21,0x00,0x00,0x20,0x3F,0x20,//h 72
  0x00,0x80,0x98,0x98,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x00,//i 73
  0x00,0x00,0x00,0x80,0x98,0x98,0x00,0x00,0x00,0xC0,0x80,0x80,0x80,0x7F,0x00,0x00,//j 74
  0x08,0xF8,0x00,0x00,0x80,0x80,0x80,0x00,0x20,0x3F,0x24,0x02,0x2D,0x30,0x20,0x00,//k 75
  0x00,0x08,0x08,0xF8,0x00,0x00,0x00,0x00,0x00,0x20,0x20,0x3F,0x20,0x20,0x00,0x00,//l 76
  0x80,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x20,0x3F,0x20,0x00,0x3F,0x20,0x00,0x3F,//m 77
  0x80,0x80,0x00,0x80,0x80,0x80,0x00,0x00,0x20,0x3F,0x21,0x00,0x00,0x20,0x3F,0x20,//n 78
  0x00,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x00,0x1F,0x20,0x20,0x20,0x20,0x1F,0x00,//o 79
  0x80,0x80,0x00,0x80,0x80,0x00,0x00,0x00,0x80,0xFF,0xA1,0x20,0x20,0x11,0x0E,0x00,//p 80
  0x00,0x00,0x00,0x80,0x80,0x80,0x80,0x00,0x00,0x0E,0x11,0x20,0x20,0xA0,0xFF,0x80,//q 81
  0x80,0x80,0x80,0x00,0x80,0x80,0x80,0x00,0x20,0x20,0x3F,0x21,0x20,0x00,0x01,0x00,//r 82
  0x00,0x00,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x33,0x24,0x24,0x24,0x24,0x19,0x00,//s 83
  0x00,0x80,0x80,0xE0,0x80,0x80,0x00,0x00,0x00,0x00,0x00,0x1F,0x20,0x20,0x00,0x00,//t 84
  0x80,0x80,0x00,0x00,0x00,0x80,0x80,0x00,0x00,0x1F,0x20,0x20,0x20,0x10,0x3F,0x20,//u 85
  0x80,0x80,0x80,0x00,0x00,0x80,0x80,0x80,0x00,0x01,0x0E,0x30,0x08,0x06,0x01,0x00,//v 86
  0x80,0x80,0x00,0x80,0x00,0x80,0x80,0x80,0x0F,0x30,0x0C,0x03,0x0C,0x30,0x0F,0x00,//w 87
  0x00,0x80,0x80,0x00,0x80,0x80,0x80,0x00,0x00,0x20,0x31,0x2E,0x0E,0x31,0x20,0x00,//x 88
  0x80,0x80,0x80,0x00,0x00,0x80,0x80,0x80,0x80,0x81,0x8E,0x70,0x18,0x06,0x01,0x00,//y 89
  0x00,0x80,0x80,0x80,0x80,0x80,0x80,0x00,0x00,0x21,0x30,0x2C,0x22,0x21,0x30,0x00,//z 90
  0x00,0x00,0x00,0x00,0x80,0x7C,0x02,0x02,0x00,0x00,0x00,0x00,0x00,0x3F,0x40,0x40,//{ 91
  0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,//| 92
  0x00,0x02,0x02,0x7C,0x80,0x00,0x00,0x00,0x00,0x40,0x40,0x3F,0x00,0x00,0x00,0x00,//} 93
  0x00,0x06,0x01,0x01,0x02,0x02,0x04,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,//~ 94
};


//void OledShowFloatWithPole_(uchar xx,uchar yy,float x,uchar lenth)
//	{
//	unsigned char data i,j;
//	unsigned char *p;
//	unsigned char xdata user_buffer[8];
//	unsigned char xdata disp_buffer[8];
//	unsigned long idata long_register;
//    p = disp_buffer;  
//		
//	if(x < 0.0)	{*p = '-';x *= -1;}
//	else		{*p = '+';}
//	p++;

//	long_register=x;

//	x=x-long_register;
//        
//	j=0;
//	while(1)
//		{
//		user_buffer[j]=long_register%10;

//		if(long_register == 0)
//			{
//			if(j==0)  { j++;}
//			break;
//			}

//		long_register /= 10;
//		j++;
//		}
//	for(i=j;i<8;i++)
//		{
//		user_buffer[i]=x*10;
//		x *= 10;
//		x -= user_buffer[i];
//		}
//	for(i=0;i<j;i++)
//		{
//		*p = user_buffer[j-i-1]+'0';p++;
//		}
//	*p = '.';p++;
//	for(i=j;i<8;i++)
//		{
//		*p = user_buffer[i]+'0';p++;
//		}
//		
//	disp_buffer[lenth] = '\0';
//	OLED_ShowString(xx,yy,disp_buffer,16);
//	}	

//void OledShowFloatWithoutPole_(uchar xx,uchar yy,float x,uchar lenth)
//	{
//	unsigned char data i,j;
//	unsigned char *p;
//	unsigned char xdata user_buffer[8];
//	unsigned char xdata disp_buffer[8];
//	unsigned long idata long_register;
//    p = disp_buffer;  

//	long_register=x;

//	x=x-long_register;
//        
//	j=0;
//	while(1)
//		{
//		user_buffer[j]=long_register%10;

//		if(long_register == 0)
//			{
//			if(j==0)  { j++;}
//			break;
//			}

//		long_register /= 10;
//		j++;
//		}
//	for(i=j;i<8;i++)
//		{
//		user_buffer[i]=x*10;
//		x *= 10;
//		x -= user_buffer[i];
//		}
//	for(i=0;i<j;i++)
//		{
//		*p = user_buffer[j-i-1]+'0';p++;
//		}
//	*p = '.';p++;
//	for(i=j;i<8;i++)
//		{
//		*p = user_buffer[i]+'0';p++;
//		}
//		
//	disp_buffer[lenth] = '\0';
//	OLED_ShowString(xx,yy,disp_buffer,16);
//	}	

//void OledShowCharacterWithPole(u8 x,u8 y,char chr,u8 Char_Size)
//	{
//	unsigned char idata i,j;
//	unsigned char *p;
//	unsigned char xdata user_buffer[8];
//	unsigned char xdata disp_buffer[8];

//    p = disp_buffer;  
//		
//	if(chr < 0)	{*p = '-';chr *= -1;}
//	else		{*p = '+';}
//	p++;
//	      
//	j=0;
//	while(1)
//		{
//		user_buffer[j]=chr % 10;

//		if(chr == 0)
//			{
//			if(j==0)  { j++;}
//			break;
//			}

//		chr /= 10;
//		j++;
//		}
//	for(i=0;i<j;i++)
//		{
//		*p = user_buffer[j-i-1]+'0';p++;
//		}	
//	*p = '\0';	//ַ
//		
//	OLED_ShowString(x,y,disp_buffer,Char_Size);	
//	}

//void OLED_On(void)
//	{
//	u8 i,n;
//	for(i=0;i<8;i++)
//		{
//		OLED_WR_Byte (0xb0+i,OLED_CMD);
//		OLED_WR_Byte (0x02,OLED_CMD);
//		OLED_WR_Byte (0x10,OLED_CMD);
//		for(n=0;n<128;n++)OLED_WR_Byte(1,OLED_DATA);
//		}
//	}
//void fill_picture(unsigned char fill_Data)	//fill_Picture
//	{
//	unsigned char m,n;
//	for(m=0;m<8;m++)
//		{
//		OLED_WR_Byte(0xb0+m,0);		//page0-page1
//		OLED_WR_Byte(0x02,0);		//low column start address
//		OLED_WR_Byte(0x10,0);		//high column start address
//		for(n=0;n<128;n++)
//			{
//			OLED_WR_Byte(fill_Data,1);
//			}
//		}
//	}

//OLEDʾ
//void OLED_Display_On(void)
//  {
//	OLED_WR_Byte(0X8D,OLED_CMD);  //SET DCDC
//	OLED_WR_Byte(0X14,OLED_CMD);  //DCDC ON
//	OLED_WR_Byte(0XAF,OLED_CMD);  //DISPLAY ON
//  }
//رOLEDʾ
//void OLED_Display_Off(void)
//	{
//	OLED_WR_Byte(0X8D,OLED_CMD);  //SET DCDC
//	OLED_WR_Byte(0X10,OLED_CMD);  //DCDC OFF
//	OLED_WR_Byte(0XAE,OLED_CMD);  //DISPLAY OFF
//	}


//void CharacterDisplayInBinary(uchar x,uchar y,uchar CharacterNubmerToDisplay)
//	{
//	uchar xdata cnt_i;
//	uchar xdata DisplayBuffer[9]="111100000";
//	for( cnt_i=0;cnt_i<8;cnt_i++)
//		{
//		if (CharacterNubmerToDisplay & 0x80)   	DisplayBuffer[cnt_i] ='1';
//		else                  					DisplayBuffer[cnt_i] ='0';
//		CharacterNubmerToDisplay <<= 1;
//		}
//	DisplayBuffer[8] ='\0';
//	OLED_ShowString(x,y,DisplayBuffer,16);
//	_nop_();
//	}


//m^n
//u32 oled_pow(u8 m,u8 n)
//{
//	u32 result=1;
//	while(n--)result*=m;
//	return result;
//}


//ʾ2
//x,y :
//len :ֵλ
//size:С
//mode:ģʽ	0,ģʽ;1,ģʽ
//num:ֵ(0~4294967295);
//void OLED_ShowNum(u8 x,u8 y,u32 num,u8 len,u8 size2)
//{
//	u8 t,temp,wide;
//	u8 enshow=0;
//	if(size2==16)wide=8;
//	else wide=6;
//	for(t=0;t<len;t++)
//		{
//		temp=(num/oled_pow(10,len-t-1))%10;
//		if(enshow==0&&t<(len-1))
//			{
//			if(temp==0)
//				{
//				OLED_ShowChar(x+wide*t,y,' ',size2);
//				continue;
//				}else enshow=1;

//			}
//	 	OLED_ShowChar(x+wide*t,y,temp+'0',size2);
//		}
//
