#include "stc8a8kxxd4.h"
#include "oled.h"
#include <intrins.h>
#include "timer.h"
#include "key.h"
#include "ADC.h"
#include "PID.h"
#include <math.h>
#include "delay.h"



//简单PID
// void calc_pid()
// {
//     P_C = error;
//     I_C = I_C + error;
//     D_C = error - previous_error;
// 	PID_value = (Kp * P_C) + (Ki * I_C) + (Kd * D_C);
//     previous_error = error;
// }

//高级PID
float PID_Calculate(float error, float dt) 
{
	
	P_C = Kp * error;
    
    if(fabs(error) < error_threshold) {//积分量防饱和
        I_C += Ki * error * dt;
        I_C = CONSTRAIN(I_C, -MAX_I, MAX_I);
    }
    
    D_C = Kd * (error - previous_error) / dt;
    previous_error = error;
    
    PID_value = P_C + I_C + D_C;
    last_PID_value = CONSTRAIN(PID_value, -MAX_PID, MAX_PID);
    return last_PID_value;
}


