#include "stc8a8kxxd4.h"
#include "timer.h"
#include <intrins.h>
#include "PID.h"
#include "OLED.h"
#include "MOTOR.h"
#include "DELAY.h"
#include "ADC.h"
sbit SW1 	= P3 ^ 2;
sbit SW2 	= P3 ^ 3;
sbit SW3	= P3 ^ 6;
sbit SW4	= P3 ^ 7;
sbit SW5	= P4 ^ 1;


void timer3(void) interrupt 19
{
	
	switch(Motor1function)			
	{
		case 0:	
		{					
			if( Timer3Count < PulseWidthOfMotor1 )		
					{motor1forwardsInput = 1;motor1backwardsInput = 0;}
			else	{motor1forwardsInput = 0;motor1backwardsInput = 0;}
			break;
		}
		case 1:	
		{
			if( Timer3Count < PulseWidthOfMotor1 )		
					{motor1forwardsInput = 0;motor1backwardsInput = 1;}
			else	{motor1forwardsInput = 0;motor1backwardsInput = 0;}
			break;
		}
		case 2:{motor1forwardsInput = 0;motor1backwardsInput = 0;break;}
		case 3:{motor1forwardsInput = 1;motor1backwardsInput = 1;break;}
		default:break;
	}

	switch(Motor2function)			
	{
		case 1:	
		{				
			if( Timer3Count < PulseWidthOfMotor2 )		
					{motor2forwardsInput = 1;motor2backwardsInput = 0;}
			else	{motor2forwardsInput = 0;motor2backwardsInput = 0;}
			break;
		}
		case 0:	
		{
			if( Timer3Count < PulseWidthOfMotor2 )		
					{motor2forwardsInput = 0;motor2backwardsInput = 1;}
			else	{motor2forwardsInput = 0;motor2backwardsInput = 0;}
			break;
		}
		case 2:{motor2forwardsInput = 0;motor2backwardsInput = 0;break;}
		case 3:{motor2forwardsInput = 1;motor2backwardsInput = 1;break;}
		default:break;
	}
	
	Timer3Count ++;					
	if(	Timer3Count == 100)
	{
		Timer3Count = 0;
		FlagOf10ms ++;

		if( SW1 == 0 )  {SW1Cnt ++;}
		else
		{
			if(SW1Cnt > 30)	{SW1LongPress = 1;SW1Cnt = 0;return;}
			if(SW1Cnt > 3) 	{SW1ShortPress = 1;SW1Cnt = 0;return;}
			SW1Cnt = 0;
		}

		if( SW2 == 0 )  {SW2Cnt ++;}
		else
		{
			if(SW2Cnt > 30)	{SW2LongPress = 1;SW2Cnt = 0;return;}
			if(SW2Cnt > 3) 	{SW2ShortPress = 1;SW2Cnt = 0;return;}
			SW2Cnt = 0;
		}
		
		if( SW3 == 0 )  {SW3Cnt ++;}
		else
		{
			if(SW3Cnt > 30)	{SW3LongPress = 1;SW3Cnt = 0;return;}
			if(SW3Cnt > 3) 	{SW3ShortPress = 1;SW3Cnt = 0;return;}
			SW3Cnt = 0;
		}
		
		if( SW4 == 0 )  {SW4Cnt ++;}
		else
		{
			if(SW4Cnt > 30)	{SW4LongPress = 1;SW4Cnt = 0;return;}
			if(SW4Cnt > 3) 	{SW4ShortPress = 1;SW4Cnt = 0;return;}
			SW4Cnt = 0;
		}
		
		if( SW5 == 0 )  {SW5Cnt ++;}
		else
		{
			if(SW5Cnt > 30)	{SW5LongPress = 1;SW5Cnt = 0;return;}
			if(SW5Cnt > 3) 	{SW5ShortPress = 1;SW5Cnt = 0;return;}
			SW5Cnt = 0;
		}
			
		TH0andTL0back = TH0andTL0;	
		((unsigned char *)&TH0andTL0)[0]  = TH0;	
		((unsigned char *)&TH0andTL0)[1]  = TL0;

		TH1andTL1back = TH1andTL1;	
		((unsigned char *)&TH1andTL1)[0]  = TH1;	
		((unsigned char *)&TH1andTL1)[1]  = TL1;

		speedTestFinished = 1;	
	}
	//左减右加
	//read_sensor_values(floatReg0,floatReg1);//扫到白为1,扫到黑为0
	
}



void initialTimer0_4(void)
{ 
	//	TMOD用于控制T0,T1是定时器还是计数器,这里都对外部晶振脉冲(11.0592MHz)进行计数  ∵时钟+计数器=定时器∴这里是用作指定脉冲下的定时器
	TMOD = 0x55;	//0x55 = 0101 0101================================================================
	/*
		符号	地址	B7		B6		B5		B4		 B3			B2		 B1		   B0
		TMOD    89H	  T1_GATE  T1_C/T  T1_M1   T1_M0   T0_GATE     T0_C/T   T0_M1    T0_M0 
						 0		 1		 0		 1		 0			 1		  0        1
	
	T0_GATE：控制定时器0，置1时只有在INT0脚为高及TR0控制位置1时才可打开定时器/计数器0。
	T0_C/T：控制定时器0用作定时器或计数器，清0则用作定时器（对内部系统时钟进行计数），置1用作
	计数器（对引脚T0/P3.4外部脉冲进行计数）。	
	T1_GATE：控制定时器1，置1时只有在INT1脚为高及TR1控制位置1时才可打开定时器/计数器1。
	T1_C/T：控制定时器1用作定时器或计数器，清0则用作定时器（对内部系统时钟进行计数），置1用作
	计数器（对引脚T1/P3.5外部脉冲进行计数）。 
	*/

	
	//对定时器/计数器T2，用特殊功能寄存器AUXR中的控制位T2_C/T来选择T2为定时器还是计数器。
	AUXR &= 0x3f;//ox3f = 0011 1111==========================================================================
	/*
		符号 	地址 	B7		B6		B5		   B4		B3		 B2		  B1		B0
 
		AUXR 	8EH    T0x12   T1x12  UART_M0x6  T2R      T2_C/T    T2x12   EXTRAM     S1ST2
						 0 		 0		  1 	  1 		 1		  1 	   1		 1
						 
						 
		//	显然这里将头两位强制置零		T0和T1强制12T模式
		
		T2R：定时器2的运行控制位 
			0：定时器2停止计数 
			1：定时器2开始计数 
			
		T2_C/T：控制定时器2用作定时器或计数器，清0则用作定时器（对内部系统时钟进行计数），置1用作计数器（对引脚T2/P1.2外部脉冲进行计数）
		
		T2x12：定时器2速度控制位 
			0：12T 模式，即CPU时钟12分频（FOSC/12） 
			1：1T模式，即CPU时钟不分频分频（FOSC/1）
	*/
	//#define FOSC 18432000L
	//此时AUXR = 0000 1110
	if(AUXR & 0x80)//0x80 = 1000 0000		如果第一位等于1 (即T0是1T模式,不分频)
	{
		TL0 = (65536 - (FOSC/timer0InterruptFrequency));_nop_();//#define  timer0InterruptFrequency 10000
		TH0 = (65536 - (FOSC/timer0InterruptFrequency))>>8;_nop_();
	}
	else									//如果第一位不等于1 (即T0是12T模式,12分频)		
	{//0.1us
		TL0 = (65536 - (FOSC/12/timer0InterruptFrequency));_nop_();//
		TH0 = (65536 - (FOSC/12/timer0InterruptFrequency))>>8;_nop_();//
	}

	if(AUXR & 0x40)//0x40 = 0100 0000		如果第二位等于1 (即T1是1T模式,不分频)
	{
		TL1 = (65536 - (FOSC/timer1InterruptFrequency));_nop_();//#define  timer1InterruptFrequency 100
		TH1 = (65536 - (FOSC/timer1InterruptFrequency))>>8;_nop_();
	}
	else									////如果第二位不等于1 (即T1是12T模式,12分频)
	{
		TL1 = (65536 - (FOSC/12/timer1InterruptFrequency));_nop_();
		TH1 = (65536 - (FOSC/12/timer1InterruptFrequency))>>8;_nop_();
	}
	
	//P_SW2的第一位置一用于解锁扩展SFR的访问权限这里用'或',即只把第一位置一,其他未改变
	P_SW2 |= 0x80; //0x80 = 1000 0000=======================================================================================
	//定时器2的8位预分频寄存器（TM2PS）
	//定时器2的时钟 ＝ 系统时钟SYSclk ÷ ( TM2PS + 1 ) 
	//这里使定时器2的时钟等于系统时钟‌（未分频）
 	TM2PS =  0x00;//========================================================================================================
	
	
	//当T2_C/T=0(AUXR第五位)时，多路开关连接到系统时钟输出，T2对内部系统时钟计数，T2工作在定时方式。当T2_C/T=1时，多路开关连接到外部脉冲输T2，即T2工作在计数方式。
	//T2的速率由特殊功能寄存器AUXR中的T2x12(AUXR第六位)决定，如果T2x12=0，T2则工作在12T模式；如果T2x12=1，T2则工作在1T模式
	if(AUXR & 0x04)	//0x04 = 	0000 0100	如果第六位等于1 (即T2是12T模式,12分频)
	{
		T2L = (65536 - (FOSC/(TM2PS+1)/timer2InterruptFrequency));_nop_();//#define  timer2InterruptFrequency 1000
		T2H = (65536 - (FOSC/(TM2PS+1)/timer2InterruptFrequency))>>8;
	}
	else							//如果第六位等于0 (即T2是1T模式,不分频)
	{
		T2L = (65536 - (FOSC/12/(TM2PS+1)/timer2InterruptFrequency));_nop_();
		T2H = (65536 - (FOSC/12/(TM2PS+1)/timer2InterruptFrequency))>>8;
	}

	P_SW2 &= ~0x80;			//  ~0x80 = 0111 1111只把第一位置零,关闭扩展寄存器=================================================
		
	
	//中断与时钟输出控制寄存器（INTCLKO）
	//这里用作关闭T0,T1,T2
	INTCLKO &= 0xf8; 	//0xf8 = 1111 1000=====================================================================================
	/*
		符号 		地址 		B7 		B6 		 B5 	B4 		B3 		B2 		 B1 	B0
	  INTCLKO       8FH          -      EX4     EX3     EX2      -     T2CLKO  T1CLKO  T0CLKO
								 1		 1 		 1		 1	  	 1		 0	  	  0	 	 0
		T0CLKO：定时器0时钟输出控制 
			0：关闭时钟输出 
			1：使能P3.5口的是定时器0时钟输出功能当定时器0计数发生溢出时，P3.5口的电平自动发生翻转。
	
		T1CLKO：定时器1时钟输出控制 
			0：关闭时钟输出 
			1：使能P3.4口的是定时器1时钟输出功能当定时器1计数发生溢出时，P3.4口的电平自动发生翻转。
	
	*/
	
	
	//定时器4/3控制寄存器（T4T3M）
	//仅最后一位强制置一
	T4T3M |=  1;	//0000 0001  这里用作按键检测=================================================================================
	/*
		符号 	  地址		B7		B6		B5		B4		B3		B2		B1		B0
	   T4T3M      D1H 		T4R   T4_C/T   T4x12  T4CLKO    T3R   T3_C/T   T3x12   T3CLKO 
																			 1	     1
		T3CLKO：定时器3时钟输出控制 
			0：关闭时钟输出 
			1：使能P0.5口的是定时器3时钟输出功能当定时器3计数发生溢出时，P0.5口的电平自动发生翻转。
	*/
	
	//仅倒数第二位强制置一
	T4T3M |=  (1 << 1);		//显然这里不分频========================================================================================
	/*
		T3x12：定时器3速度控制位 
			0：12T 模式，即CPU时钟12分频（FOSC/12） 
			1：1T模式，即CPU时钟不分频分频（FOSC/1）
	*/
	P_SW2 |= 0x80; 	//P_SW2的第一位置一用于解锁扩展SFR的访问权限这里用'或',即只把第一位置一,其他未改变=================================
	
	//定时器3的8位预分频寄存器（TM3PS）
	//定时器3的时钟 ＝ 系统时钟SYSclk ÷ ( TM3PS + 1 ) 
	//这里使定时器3的时钟等于系统时钟‌（未分频）
	
 	TM3PS =  0x00;//============================================================================================================
	
	
	//定时器4的8位预分频寄存器（TM4PS）
	//定时器4的时钟 ＝ 系统时钟SYSclk ÷ ( TM4PS + 1 )
	//这里使定时器4的时钟等于系统时钟‌（未分频）
	TM4PS =  0x00;//============================================================================================================
	
	if(T4T3M & 0x02)//0x02 = 0000 0010 如果T4T3M倒数第二位等于0(即T3是12T模式,12分频)
	{
		T3L = (65536 - (FOSC/(TM3PS+1)/timer3InterruptFrequency));_nop_();//#define  timer3InterruptFrequency 10000
    	T3H = (65536 - (FOSC/(TM3PS+1)/timer3InterruptFrequency))>>8;_nop_();
	}
	else				//如果T4T3M倒数第二位不等于0(即T3是1T模式,不分频)
	{
		T3L = (65536 - (FOSC/12/(TM3PS+1)/timer3InterruptFrequency));_nop_();
    	T3H = (65536 - (FOSC/12/(TM3PS+1)/timer3InterruptFrequency))>>8;_nop_();
	}


	if(T4T3M & 0x20)	
	{
		T4L = (65536 - (FOSC/(TM4PS+1)/timer4InterruptFrequency));_nop_();//#define  timer4InterruptFrequency 100
    	T4H = (65536 - (FOSC/(TM4PS+1)/timer4InterruptFrequency))>>8;_nop_();
	}
	else
	{
		T4L = (65536 - (FOSC/12/(TM4PS+1)/timer4InterruptFrequency));_nop_();
    	T4H = (65536 - (FOSC/12/(TM4PS+1)/timer4InterruptFrequency))>>8;_nop_();
	}
	
	//关闭扩展
	P_SW2 &= ~0x80;		
	
	//IE2（中断使能寄存器2）
	IE2 |= (1 << 5);// 	0010 0000  这里让定时/计数器T3的溢出中断允许位(即允许中断3)
	
	T4T3M |=  (1 << 3);	//0000 1000		即定时器3的开始运行
	
	/*
		PT0H,PT0：定时器0中断优先级控制位 
		00：定时器0中断优先级为0级（最低级） 
		01：定时器0中断优先级为1级（较低级） 
		10：定时器0中断优先级为2级（较高级） 
		11：定时器0中断优先级为3级（最高级） 
	*/
	
	//显然这里将定时器0中断优先级为3级（最高级）
	//中断优先级控制寄存器 
	IPH |= 0x02;//0x02 = 0000 0010

	//中断优先级控制寄存器 	
	IP  |= 0x02;//0x02 = 0000 0010	
	
	TR0 = 1; //启动定时器0
	TR1 = 1; //启动定时器1
}



void DelayMs( unsigned int delay_time)
	{
	unsigned int delay_cnt;
	while(delay_time--)
       {
       for(delay_cnt=0;delay_cnt<200;delay_cnt++)
			{
            _nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();
			_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();
			_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();
            }
       _nop_();
       }
	_nop_();
	}

